--
-- Self-Leveling v2.0
-- Specialization for Multi Self-Leveling 
--
-- @author  	***Gya*** IFF_Team( http://web.italianfarmers.net/ )
-- @version 	v2.0
-- @date  		08/08/2013
-- @history:	v1.0 - Initial version 01/09/2012
--


Fiat1000DT = {};


function Fiat1000DT.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Fiat1000DT:load(xmlFile)

	self.fan = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Reut#index"));
	self.fan1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Reut1#index"));
	self.fan2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.Reut2#index"));
    self.fanRotation = 0;
	

	self.wellenCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.Allradwellen#count"), 0);	 
	self.Wellen = {};
	self.Speed = {};
	if self.wellenCount ~= 0 and self.wellenCount ~= nil then
	    for i=1, self.wellenCount do
	        local RFWheel = string.format("vehicle.Allradwellen.RFWheel%d", i)
		    self.Wellen[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, RFWheel .. "#index"));
	    end;
	end;
	--[[
	
	-- Switches----
	
	self.numSwitches = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.switches#count"),0);
	self.switch = {};
	for i=1, self.numSwitches do
		local objname = string.format("vehicle.switches.switch" .. "%d", i);
		self.switch[i] = {};
		self.switch[i] = Utils.indexToObject(self.components, getXMLString(xmlFile, objname .. "#index"));
	end;
	
	   -- Leve ---
	self.levaindicatori = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levaindicatori#index"));
	self.levalater = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levalater#index"));
	self.levalongi = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.levalongi#index"));
	self.ActivLater = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ActivLater#index"));
	self.ActivFront = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.ActivFront#index"));
	]]--	
	
	-- Zapfwellenstummel / Powershaft rotation
	self.stummelIndex = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations#ReferendRTIndex"));
	
	-- Lan_RPM / Speedometer animation
	self.Lan_RPM = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.Lan_RPM#Index"));
	self.tachoZeigerMultiplicator = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.TractorAnimations.Lan_RPM#multiplicator"), 10);
	self.tachoZeigerMaxRotation = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.TractorAnimations.Lan_RPM#maxRotation"), 235);
	
	-- LAN_Fuel / fuel level display
	self.LAN_Fuel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.LAN_Fuel#Index"));
	self.LAN_FuelMaxRot = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.TractorAnimations.LAN_Fuel#maxRotation"), 60);
	
	-- LAN_Temp / temperature Display animation
	self.LAN_Temp = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.LAN_Temp#Index"));
	self.LAN_TempMaxRot = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.TractorAnimations.LAN_Temp#maxRotation"));
	self.tempCnt = 0;

	-- Ladekontrollleuchte / Batterie load light
	self.ladeLeuchte = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.LadeKontrollLeuchte#index"));
	setVisibility(self.ladeLeuchte, false);
	self.ladeLeuchteOn = 0;
	self.ladeTimer = 50;

	-- Hydraulic Handle
	self.PitchArm = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.PitchArm#Index"));
	self.PitchArmRefNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.PitchArm#refNode"));
	
	self.PitchArmTs = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.PitchArmTs#Index"));
	self.PitchArmTsRefNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.TractorAnimations.PitchArmTs#refNode"));
	self.isSelectable = true;
		
	self.cycleRoundMax = 20;
	self.currentCycle = 0;
	self.lastRpm = 0;
	self.displayValue = 0;
	self.rpmMeterValue = 30;
end;

function Fiat1000DT:delete()
end;
function Fiat1000DT:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Fiat1000DT:readStream(streamId, connection)
end;
function Fiat1000DT:writeStream(streamId, connection)
end;
function Fiat1000DT:keyEvent(unicode, sym, modifier, isDown)
end;

function Fiat1000DT:update(dt)	

 	if self.isMotorStarted then
	   if self.motor.lastMotorRpm > 0.008 then
		self.fanRotation = self.fanRotation + 12;
		setRotation(self.fan,  0, 0, Utils.degToRad(self.fanRotation));
		setRotation(self.fan1,  0, 0, Utils.degToRad(self.fanRotation));
		setRotation(self.fan2,  0, 0, Utils.degToRad(self.fanRotation));
	else
		setRotation(self.fan, 0, 0, 0);
		setRotation(self.fan1, 0, 0, 0);
		setRotation(self.fan2, 0, 0, 0);
		end;
	end;
	
if self.isMotorStarted then
 if self:getIsActiveForInput() then
		if InputBinding.isPressed(InputBinding.HydroPT1) then
			self:setAnimationTime(1, self.animationParts[1].currentPosition+(self.animationParts[1].offSet+dt), false);
		elseif InputBinding.isPressed(InputBinding.HydroPT2) then
			self:setAnimationTime(1, self.animationParts[1].currentPosition-(self.animationParts[1].offSet+dt), false);
		end;
	end;
	if self:getIsActive() then	
	    if self.wellenCount ~= 0 and self.wellenCount ~= nil then
		  local getRx, getRy, getRz = getRotation(self.wheels[3].repr);			
	      for i=1, self.wellenCount do
	        setRotation(self.Wellen[i], getRx * 3, 0, 0);
	    end;
	end;
end;

end;
	if self:getIsActive() then
		if self.isMotorStarted then
			-- Ladekontrollleuchte / Batterie load light
			if self.ladeLeuchteOn == 1 then
				setVisibility(self.ladeLeuchte, true);
				if self.movingDirection ~= 0 then
					self.timerTrue = true;
				end;
				if self.timerTrue then
					self.ladeTimer = math.max(self.ladeTimer - 0.1, 0);
				end;
				if self.ladeTimer == 0 then
					setVisibility(self.ladeLeuchte, false);
					self.timerTrue = nil;
					self.ladeLeuchteOn = 0;
					self.ladeTimer = 50;
				end;
			end;
			
			-- LAN_Fuel / fuel level display
			local actualTankInhalt = 0;
			if self.fuelCapacity > 0 then
				actualTankInhalt = (self.fuelFillLevel / self.fuelCapacity + 0.0001) * 100;
			end;
			local rotValue = (self.LAN_FuelMaxRot / self.fuelCapacity) * actualTankInhalt;
			setRotation(self.LAN_Fuel, 0, Utils.degToRad(rotValue), 0);
	
			-- Zapfwellenstummel / Powershaft rotation
			rotate(self.stummelIndex, 0,0,0.001*dt);
			
			-- Temperaturanzeiger / temperature display animation und / and berechnung / calculation
			if self.tempCnt < 3000 then
				setRotation(self.LAN_Temp, 0, Utils.degToRad(-(self.LAN_TempMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = self.tempCnt + 0.5;
			elseif self.tempCnt > 3000 and self.tempCnt < 6000 then
				setRotation(self.LAN_Temp, 0, Utils.degToRad(-(self.LAN_TempMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.2, 10000);			
			else
				setRotation(self.LAN_Temp, 0, Utils.degToRad(-(self.LAN_TempMaxRot/10000)*self.tempCnt), 0);
				self.tempCnt = math.min(self.tempCnt + 0.05, 10000);
			end;			
		end;
	else
		self.tempCnt = math.max(self.tempCnt - 0.08, 0);
	end;
		
	if self:getIsActive() then	
				--if self.displaySelectorMode == 0 then
		if self.isMotorStarted then
			if self.currentCycle < self.cycleRoundMax then
				self.currentCycle = self.currentCycle + 1;
				self.currentRPM = self.motor.lastMotorRpm;
				if self.rpmMeterValue ~= nil then
					self.currentRPM = self.rpmMeterValue;
				end;
				self.lastRpm = math.max((self.lastRpm + self.currentRPM)/2);
			else
				self.currentCycle = 0;
				self.displayValue = self.lastRpm;
				self.motor.lastMotorRpm = self.motor.lastMotorRpm + 0.01;
			end;
		else
			self.displayValue = 0;
		end;
		
		-- Lan_RPM / speedometer animation
			self.RpmMath = math.min(100, math.max(0, self.displayValue*self.motor.lastMotorRpm/1900));
			local RpmMath = math.rad(math.random(-20,5) + self.displayValue / self.rpmMeterValue*3600 );
			--self.RpmMath = math.min(math.max(self.lastRpm / self.rpmMeterValue*3600));
			local zeigerRotation = self.RpmMath * self.tachoZeigerMultiplicator;
			if zeigerRotation <= self.tachoZeigerMaxRotation then
				setRotation(self.Lan_RPM, 0, -Utils.degToRad(zeigerRotation), 0);
			else
				setRotation(self.Lan_RPM, 0, -Utils.degToRad(self.tachoZeigerMaxRotation), 0);
		end;				
	end;
end;


function Fiat1000DT:draw()
end;

function Fiat1000DT:updateTick(dt) 

	if self.PitchArm ~= nil then
		-- set correct rotation on PitchArm
		local x, y, z = getRotation(self.PitchArmRefNode);
		setRotation(self.PitchArm, x * (-1.8), y, z);	
	end;

	if self.PitchArmTs ~= nil then
		-- set correct rotation on PitchArm
		local x, y, z = getTranslation(self.PitchArmTsRefNode);
		setTranslation(self.PitchArmTs, x , y, z * (0.5));	
	end;
end;

function Fiat1000DT:onEnter()
	self.ladeLeuchteOn = 1;
end;
function Fiat1000DT:onLeave()
	self.ladeLeuchteOn = 0;
end;
function Fiat1000DT:stopMotor()
	if self.LAN_Fuel ~= nil then
			setRotation(self.LAN_Fuel, 0, 0, 0);
	end;
end;
--[[
function Fiat1000DT:stopMotor()
	self.ladeLeuchteOn = 1;
end;
function Fiat1000DT:startMotor()
	self.ladeLeuchteOn = 0;
end;]]--
  
function Fiat1000DT:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;